<template>
  <q-page padding>
    <q-table
      row-key="id"
      :columns="columns"
      :data="products"
      :filter="filter"
    >
      <template v-slot:top-left>
        <div class="text-h6">
          Lista de Productos <q-btn color="primary" icon-right="fas fa-plus-circle" label="Crear" @click="add" />
        </div>
      </template>
      <template v-slot:top-right>
        <q-input borderless debounce="300" v-model="filter" placeholder="Buscar">
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>
      <template v-slot:body-cell-action="props">
        <td class="text-center">
          <q-btn-group>
            <q-btn color="primary" icon="fas fa-edit" size="0.75em" @click="edit(props.row)" />
            <q-btn color="primary" icon="fas fa-trash-alt" size="0.75em" @click="destroy({ id: props.row._id, index: props.row.__index })" />
          </q-btn-group>
        </td>
      </template>
    </q-table>
    <router-view />
  </q-page>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
  data () {
    return {
      columns: [
        { name: 'brand', label: 'Marca', field: row => row.brand.name },
        { name: 'name', label: 'Nombre', field: row => row.product.name },
        { name: 'presentation', label: 'Presentation', field: row => row.presentation },
        { name: 'price', label: 'Precio', field: row => parseFloat(row.price).toFixed(2) },
        { name: 'action', label: 'Acciones', align: 'center' }
      ],
      filter: null
    }
  },
  mounted () {
    this.$store.dispatch('businessProduct/getAll')
  },
  computed: {
    ...mapGetters({
      products: 'businessProduct/all'
    })
  },
  methods: {
    add () {
      this.$router.push({ name: 'business.product.create' })
    },
    edit (product) {
      this.$router.push({ name: 'business.product.edit', params: { product_id: product._id }, query: { index: product.__index } })
    },
    destroy ({ id, index }) {
      this.$q.dialog({
        title: 'Confirmar',
        message: '¿Está seguro de eliminar el registro?',
        cancel: true,
        persistent: true
      }).onOk(async () => {
        let query, color, icon
        try {
          query = await this.$store.dispatch('businessProduct/destroy', { id, index })
          color = 'info'
          icon = 'sentiment_satisfied'
        } catch (err) {
          query = err
          color = 'negative'
          icon = 'sentiment_dissatisfied'
        }
        const { message } = query
        this.$q.notify({
          position: 'top',
          message,
          color,
          icon
        })
      })
    }
  }
}
</script>
